<%
' HTMLText 1.5.1
' HTML to Text and Text to HTML functions
' Written by Hunter Beanland
' http://beanland.net.au/
' hunter@beanland.net.au

Function HTML2Text(ByVal TextHTML)
	Dim regEx, objMatches, objMatch, CharCodes, CharNames, CharLoop
	CharCodes = Split("34,38,60,62,160,161,162,163,164,165,166,166,167,168,168,169,170,171,172,173,174,175,175,176,177,178,179,180,181,182,183,184," &_
		"185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220," &_
		"221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,402," &_
		"913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,945,946,947,948,949,950,951,952,953,954,955,956," &_
		"957,958,959,960,961,962,963,964,965,966,967,968,969,977,978,982,8226,8230,8242,8243,8254,8260,8472,8465,8476,8482,8501,8592,8593,8594,8595,8596," &_
		"8629,8656,8657,8658,8659,8660,8704,8706,8707,8709,8711,8712,8713,8715,8719,8722,8722,8727,8730,8733,8734,8736,8869,8870,8745,8746,8747,8756,8764," &_
		"8773,8773,8800,8801,8804,8805,8834,8835,8836,8838,8839,8853,8855,8869,8901,8968,8969,8970,8971,9001,9002,9674,9824,9827,9829,9830,338,339,352," &_
		"353,376,710,732,8194,8195,8201,8204,8205,8206,8207,8211,8212,8216,8217,8218,8220,8221,8222,8224,8225,8240,8249,8250",",")
	CharNames = Split("quot,amp,lt,gt,nbsp,iexcl,cent,pound,curren,yen,brvbar,brkbar,sect,uml,die,copy,ordf,laquo,no,shy,reg,macr,hibar,deg,plusmn," &_
		"sup2,sup3,acute,micro,para,middot,cedil,sup1,ordm,raquo,frac14,frac12,frac34,iquest,Agrave,Aacute,Acirc,Atilde,Auml,Aring,AElig,Ccedil,Egrave," &_
		"Eacute,Ecirc,Euml,Igrave,Iacute,Icirc,Iuml,ETH,Ntilde,Ograve,Oacute,Ocirc,Otilde,Ouml,times,Oslash,Ugrave,Uacute,Ucirc,Uuml,Yacute,THORN,szlig," &_
		"agrave,aacute,acirc,atilde,auml,aring,aelig,ccedil,egrave,eacute,ecirc,euml,igrave,iacute,icirc,iuml,eth,ntilde,ograve,oacute,ocirc,otilde,ouml," &_
		"divide,oslash,ugrave,uacute,ucirc,uuml,yacute,thorn,yuml,fnof,Alpha,Beta,Gamma,Delta,Epsilon,Zeta,Eta,Theta,Iota,Kappa,Lambda,Mu,Nu,Xi,Omicron,Pi," &_
		"Rho,Sigma,Tau,Upsilon,Phi,Chi,Psi,Omega,alpha,beta,gamma,delta,epsilon,zeta,eta,theta,iota,kappa,lambda,mu,nu,xi,omicron,pi,rho,sigmaf,sigma,tau," &_
		"upsilon,phi,chi,psi,omega,thetasym,upsih,piv,bull,hellip,prime,Prime,oline,frasl,weierp,image,real,trade,alefsym,larr,uarr,rarr,darr,harr,crarr," &_
		"lArr,uArr,rArr,dArr,hArr,forall,part,exist,empty,nabla,isin,notin,ni,prod,sum,minus,lowast,radic,prop,infin,ang,and,or,cap,cup,int,there4,sim,cong," &_
		"asymp,ne,equiv,le,ge,sub,sup,nsub,sube,supe,oplus,otimes,perp,sdot,lceil,rceil,lfloor,rfloor,lang,rang,loz,spades,clubs,hearts,diams,OElig,oelig," &_
		"Scaron,scaron,Yuml,circ,tilde,ensp,emsp,thinsp,zwnj,zwj,lrm,rlm,ndash,mdash,lsquo,rsquo,sbquo,ldquo,rdquo,bdquo,dagger,Dagger,permil,lsaquo,rsaquo",",")
	Set regEx = New RegExp
	regEx.IgnoreCase = True
	regEx.Multiline = True
	regEx.Global = True
	'Remove rubbish before the body
	if instr(1,TextHTML,"<body",1) >0 then TextHTML = right(TextHTML,len(TextHTML)-instr(1,TextHTML,"<body",1)+1)
	'Remove space/tabs
	regEx.Pattern = "\s+"
	TextHTML = regEx.Replace(TextHTML, " ")
	'Insert new formatting
	regEx.Pattern = "<br[^>]*>|<p[^>]*>|<div[^>]*>|<tr[^>]*>|<li[^>]*>"
	TextHTML = regEx.Replace(TextHTML, vbCRLF)
	regEx.Pattern = "<td[^>]*>"
	TextHTML = regEx.Replace(TextHTML, vbTab)
	'Remove style and script structures.
	regEx.Pattern = "<style[^>]*>.*</style>"
	TextHTML = regEx.Replace(TextHTML, "")
	regEx.Pattern = "<script[^>]*>.*</script>"
	TextHTML = regEx.Replace(TextHTML, "")
	'Convert HTML links to Text and URL. If link are text are same, ignore text 
	regEx.Pattern = "<a[^>]+href=['|""]([^'|""]*)['|""][^>]*>\1</a>"
	TextHTML = regEx.Replace(TextHTML, " $1 ")
	regEx.Pattern = "<a[^>]+href=['|""]([^'|""]+)['|""][^>]*>(.*)</a>"
	TextHTML = regEx.Replace(TextHTML, " $2 $1 ")
	'Line feeds and other tags inside the anchor are sometimes missed by the last statement (and this one misses ones the last want catches)
	regEx.Pattern = "<a[^>]+href=['|""]([^'|""]+)['|""][^>]*>([^<]*)"
	TextHTML = regEx.Replace(TextHTML, " $2 $1 ")
	'Strip remaining HTML
	regEx.Pattern = "<[^>]*>"
	TextHTML = regEx.Replace(TextHTML, " ")
   	'Replace html encoded non-named chars (&#64; = @). Supports double byte.
	regEx.Pattern = "&#(\d+);"
	Set objMatches = regEx.Execute(TextHTML)
	on error resume next
	For Each objMatch In objMatches
		if clng(objMatch.SubMatches(0)) > 255 or Session.CodePage <> 1252 then
    		TextHTML = Replace(TextHTML, objMatch.value, chrW(objMatch.SubMatches(0)))
    	else
    		TextHTML = Replace(TextHTML, objMatch.value, chr(objMatch.SubMatches(0)))
    	end if	
    Next
   	'Replace html encoded named chars (&lt; = <). Supports double byte.
	regEx.Pattern = "&([A-Za-z0-9]*);"
	Set objMatches = regEx.Execute(TextHTML)
	For Each objMatch In objMatches
		for CharLoop = 0 to ubound(CharNames)
			if objMatch.SubMatches(0) = CharNames(CharLoop) then
				if clng(CharCodes(CharLoop)) > 255 or Session.CodePage <> 1252 then
   					TextHTML = Replace(TextHTML, objMatch.value, chrW(CharCodes(CharLoop))) 
    			else	
   					TextHTML = Replace(TextHTML, objMatch.value, chr(CharCodes(CharLoop)))
    			end if
    			exit for
   			end if
		next
    Next
	on error goto 0
	'Remove surplus space and line feeds & left trim (from tag removal)
	regEx.Multiline = True
	regEx.Pattern = "^ +"
	TextHTML = regEx.Replace(TextHTML, "")
	do while instr(1,TextHTML,"  ") > 0
		TextHTML = Replace(TextHTML,"  ", " ")
	loop
	do while instr(1,TextHTML,vbCRLF & vbCRLF & vbCRLF) > 0
		TextHTML = Replace(TextHTML,vbCRLF & vbCRLF & vbCRLF, vbCRLF & vbCRLF)
	loop
	set regEx = nothing
	set objMatches = nothing
	set objMatch = nothing
	HTML2Text = TextHTML
End Function

Function Text2HTML(ByVal TextHTML)
	Dim regEx, objMatches, objMatch
	Set regEx = New RegExp
	regEx.IgnoreCase = True
	regEx.Global = True
	'Insert spaces around link with <> or () around it before the encode so it does not become part of the link
	regEx.Pattern = "([<|(])(http|ftp)(.*)([>|)])"
	TextHTML = regEx.Replace(TextHTML, "$1 $2$3 $4")
	'Standard encode
	TextHTML = Server.HTMLEncode(TextHTML)
	'Replace URLs with a link
	regEx.Pattern = "(http|ftp)(\S*)"
	TextHTML = regEx.Replace(TextHTML, "<a href=""$1$2"">$1$2</a>")
	'Replace standard formating
	TextHTML = replace(TextHTML,vbLF & vbLF,"<p />")
	TextHTML = replace(TextHTML,vbCRLF,"<br />")
	TextHTML = replace(TextHTML,vbLF,"<br />")
	TextHTML = replace(TextHTML,vbCR,"<br />")
	TextHTML = replace(TextHTML,vbTab,"&nbsp;&nbsp;&nbsp;")
	'Replace mutli spaces
	While InStr(1, TextHTML, "  ") > 0
		TextHTML = Replace(TextHTML, "  ", "&nbsp;&nbsp;")
	Wend
	'add decent font - remove this if you don't want it.
	set regEx = nothing
	Text2HTML = "<font face='arial' size='2'>" & TextHTML & "</font>"
End Function

Function ContainsHTML(ByVal TextHTML)
	'Detects HTML tags. Use if you are unsure if there is HTML in your text. Not fool proof
	'(if you run HTML2Text and there is no HTML in the text, then the text formatting will be lost)
	Dim regEx
	Set regEx = New RegExp
	regEx.IgnoreCase = True
	regEx.Global = True
	regEx.Pattern = "<([^>]*)>[^<]*<\/\1>|<br[^>]*>|<p[^>]*>|<img[^>]*>"
	ContainsHTML = regEx.Test(TextHTML)
End Function

%>
